main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
]

story7/urls.py
from django.contrib import admin
from django.urls import include, path
from story8 import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('story8/', views.story8),
    path('data/', views.fungsi_data),
    path('story9/', include('story9.urls')),
]

story8/urls.py
from django.urls import path

from . import views

app_name = 'story8'

urlpatterns = [
    path('', views.story8),
]

story9/urls.py
from django.urls import path
from . import views
from django.contrib.auth import views as auth 

app_name = 'story9'

urlpatterns = [
    path('', views.index, name='index'),
    path('signup/', views.signupView, name='signup'),
    path('login/', auth.LoginView.as_view(template_name='story9/login.html'), name='login'),
    path('logout/', auth.LogoutView.as_view(template_name='story9/logout.html'), name='logout'),
    path('profile/', views.profileView, name='profile'),

]

main/models.py
from django.db import models

# Create your models here.

story8/models.py
from django.db import models

# Create your models here.

story9/models.py
from django.db import models
from django.contrib.auth.models import User
from django.db.models.signals import post_save
from django.dispatch import receiver

class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    image = models.CharField(max_length=100, default="https://www.kindpng.com/picc/m/22-223863_no-avatar-png-circle-transparent-png.png")
    fname = models.CharField(max_length=100, default="")
    lname = models.CharField(max_length=100, default="")

    def __str__(self):
        return f'{self.user.username} Profile' 

@receiver(post_save, sender=User)
def create_profile(sender, instance, created, **kwargs): 
    if created:
        Profile.objects.create(user=instance)

@receiver(post_save, sender=User)
def save_profile(sender, instance, created, **kwargs): 
    instance.profile.save()

story9/forms.py
from django import forms
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from crispy_forms.helper import FormHelper
from .models import Profile

class RegisterForm(UserCreationForm):
    class Meta:
        model = User
        fields = [
            'username',
            'password1',
            'password2',
        ]

class ProfileForm(forms.ModelForm):
    class Meta:
        model = Profile
        fields = '__all__'
        exclude = ['user']
        widgets = {
            'image': forms.TextInput(
				attrs={
                    'class': 'form-control',
                    'id': 'image',
                    'placeholder': 'Image URL',
					}
				),
            'fname': forms.TextInput(
				attrs={
                    'class': 'form-control',
                    'id': 'fname',
                    'placeholder': 'First Name',
					}
				),
            'lname': forms.TextInput(
				attrs={
                    'class': 'form-control',
                    'id': 'lname',
                    'placeholder': 'Last Name',
					}
				),
        }
    
    def __init__(self, *args, **kwargs):
        super(ProfileForm, self).__init__(*args, **kwargs)
        self.helper = FormHelper(self)
        self.fields['image'].label = "New profile picture"
        self.fields['fname'].label = "First Name"
        self.fields['lname'].label = "Last Name"

main/views.py
from django.shortcuts import render


def home(request):
    return render(request, 'main/home.html')

story8/views.py
from django.shortcuts import render
from django.http import HttpResponse, JsonResponse
import requests
import json


def story8(request):
    response = {}
    return render(request, 'story8/story8.html', response)

def fungsi_data(request):
    url = "https://www.googleapis.com/books/v1/volumes?q=" + request.GET['q']
    ret = requests.get(url)
    print(ret.content)
    data = json.loads(ret.content)
    return JsonResponse(data, safe=False)

story9/views.py
from django.shortcuts import render, redirect
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.forms import UserCreationForm

from .forms import RegisterForm, ProfileForm


# Create your views here.
def index(request):
    context = {
    }
    print(request.user.is_authenticated)
    

    return render(request, 'story9/index.html', context )

def signupView(request):
    if request.method == 'POST':
        form =RegisterForm(request.POST)
        if form.is_valid():
            form.save()
            messages.add_message(request, messages.SUCCESS, f'Successfully registered. You can now log in.')
            return redirect('story9:login')
    else:
        form = RegisterForm()

    context = {
        'form': form
    }
    return render(request, 'story9/signup.html', context)

@login_required
def profileView(request):   
    if request.method == 'POST':
        form = ProfileForm(request.POST, instance=request.user.profile)
        if form.is_valid():
            form.save()
            messages.add_message(request, messages.SUCCESS, f'Successfully updated profile.')
            return redirect('story9:profile')    
    else: 
        form = ProfileForm(instance=request.user.profile)

    context = {
        'form': form
    }
    return render(request, 'story9/profile.html', context)


main/templates/main/home.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
  <title>Story 7</title>
  
{% endblock meta %}

{% block content %}

<div class="container-fluid py-5">
  <div class="header">
    <div class="container d-flex justify-content-center">
      <h1>Story 7</h1>
    </div>
    <div class="container text-center">
        <h2>Accordion</h2>
    </div>
  </div>
</div>

<div class="container ">
  <div class="text-center">
    <div class="wrapper">
      
      <div class="acc-item">
        <div class="acc-header">
          <div class="float-right">
            <i class="fas fa-chevron-circle-up move-up"></i>
            <i class="fas fa-chevron-circle-down move-down"></i>
          </div>
          <div class="title">
            Aktivitas Saat Ini
          </div>
        </div>
        <div class="acc-body">
          <p>Kuliah dan tidur.</p>
        </div>
      </div>
      
      <div class="acc-item">
        <div class="acc-header">
          <div class="float-right">
            <i class="fas fa-chevron-circle-up move-up"></i>
            <i class="fas fa-chevron-circle-down move-down"></i>
          </div>
          <div class="title">
            Pengalaman Kerja
          </div>
        </div>
        <div class="acc-body">
          <p>Belum ada</p>
        </div>
      </div>
      
      <div class="acc-item">
        <div class="acc-header">
          <div class="float-right">
            <i class="fas fa-chevron-circle-up move-up"></i>
            <i class="fas fa-chevron-circle-down move-down"></i>
          </div>
          <div class="title">
            Prestasi
          </div>
        </div>
        <div class="acc-body">
          <p>Belum ada</p>
        </div>
      </div>
      
      <div class="acc-item">
        <div class="acc-header">
          <div class="float-right">
            <i class="fas fa-chevron-circle-up move-up"></i>
            <i class="fas fa-chevron-circle-down move-down"></i>
          </div>
          <div class="title">
            Hobi
          </div>
        </div>
        <div class="acc-body">
          <p>Sedang mencari</p>
        </div>
      </div>
      
    </div>
  </div>
</div>
<script src="{% static 'js/accordion.js' %}"></script>
{% endblock content %}

story8/templates/story8/story8.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
  <title>Story 8</title>
  
{% endblock meta %}

{% block content %}

<div class="container-fluid py-5">
  <div class="header">
    <div class="container d-flex justify-content-center">
      <h1>Story 8</h1>
    </div>
    <div class="container text-center">
        <h2>Ajax</h2>
    </div>
  </div>
</div>
<div class="container">

  <form class="form-inline mb-5">
    <i class="fas fa-search" aria-hidden="true"></i>
    <input id="keyword" class="form-control form-control-sm ml-3 w-50" type="text" placeholder="Cari Buku"
      aria-label="Search">
  </form>
  <table id="daftar-buku" class="table table-bordered table-striped">
  </table>
</div>
<script src="{% static 'js/ajaxbook.js' %}"></script>
{% endblock content %}


story9/templates/story9/index.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
  <title>Story 9</title>
  
{% endblock meta %}

{% block content %}

<nav class="navbar bg-dark navbar-expand-lg">
    <a class="navbar-brand" href="#" style="color:white">
      Story 9
    </a>

    <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
        <div class="navbar-nav mr-auto">
          <a class="nav-item nav-link" href="{% url 'story9:index' %}" style="color:white">Home</a>
        </div>
  
        {% if user.is_authenticated %}
        <div class="navbar-nav ml-auto">  
          <a class="nav-item nav-link" href="{% url 'story9:logout' %}" style="color:white">Log Out</a>
        </div>
        {% else %}
        <div class="navbar-nav ml-auto">  
          <a class="nav-item nav-link" href="{% url 'story9:login' %}" style="color:white">Log In</a>
          <a class="nav-item nav-link" href="{% url 'story9:signup' %}" style="color:white">Sign Up</a>
        </div>
        {% endif %}
      
    </div>
  </nav>

  <div class = "container pt-4">
    {% if user.is_authenticated %}
    <h1>Halo {{user}}</h1>
    <br>
    <a class="nav-item nav-link" href="{% url 'story9:profile' %}">Lihat Profile</a>
    {% else %}
    <h1>Login terlebih dahulu</h1>
    <br>
    <a class="nav-item nav-link" href="{% url 'story9:login' %}">Login</a>
    {% endif %}
  </div>
{% endblock content %}

story9/templates/story9/login.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
  <title>Story 9|LOGIN</title>
  
{% endblock meta %}
{% load crispy_forms_tags %}
{% block content %}

<nav class="navbar bg-dark navbar-expand-lg">
    <a class="navbar-brand" href="#" style="color:white">
      Story 9
    </a>

    <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
      <div class="navbar-nav mr-auto">
        <a class="nav-item nav-link" href="{% url 'story9:index' %}" style="color:white">Home</a>
      </div>

      {% if user.is_authenticated %}
      <div class="navbar-nav ml-auto">  
        <a class="nav-item nav-link" href="{% url 'story9:logout' %}" style="color:white">Log Out</a>
      </div>
      {% else %}
      <div class="navbar-nav ml-auto">  
        <a class="nav-item nav-link" href="{% url 'story9:login' %}" style="color:white">Log In</a>
        <a class="nav-item nav-link" href="{% url 'story9:signup' %}" style="color:white">Sign Up</a>
      </div>
      {% endif %}
      
    </div>
  </nav>

  <div class = "container pt-4">
      <form method = "POST">
          {% csrf_token %}
          {{ form|crispy }}
          <button id="loginButton" class="btn btn-success" type="submit">Login</button>
      </form>
  </div>
{% endblock content %}

story9/templates/story9/logout.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
  <title>Story 9|LOGIN</title>
  
{% endblock meta %}

{% block content %}

<nav class="navbar bg-dark navbar-expand-lg">
    <a class="navbar-brand" href="#" style="color:white">
      Story 9
    </a>

    <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
      <div class="navbar-nav mr-auto">
        <a class="nav-item nav-link" href="{% url 'story9:index' %}" style="color:white">Home</a>
      </div>

      {% if user.is_authenticated %}
      <div class="navbar-nav ml-auto">  
        <a class="nav-item nav-link" href="{% url 'story9:logout' %}" style="color:white">Log Out</a>
      </div>
      {% else %}
      <div class="navbar-nav ml-auto">  
        <a class="nav-item nav-link" href="{% url 'story9:login' %}" style="color:white">Log In</a>
        <a class="nav-item nav-link" href="{% url 'story9:signup' %}" style="color:white">Sign Up</a>
      </div>
      {% endif %}
      
    </div>
  </nav>

  <div class = "container pt-4">
      Telah Logout
      <a class="nav-item nav-link" href="{% url 'story9:index' %}">Kembali</a>
  </div>
{% endblock content %}

story9/templates/story9/profile.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
  <title>Story 9</title>
  
{% endblock meta %}
{% load crispy_forms_tags %}
{% block content %}

<nav class="navbar bg-dark navbar-expand-lg">
    <a class="navbar-brand" href="#" style="color:white">
      Story 9
    </a>

    <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
        <div class="navbar-nav mr-auto">
          <a class="nav-item nav-link" href="{% url 'story9:index' %}" style="color:white">Home</a>
        </div>
  
        {% if user.is_authenticated %}
        <div class="navbar-nav ml-auto">  
          <a class="nav-item nav-link" href="{% url 'story9:logout' %}" style="color:white">Log Out</a>
        </div>
        {% else %}
        <div class="navbar-nav ml-auto">  
          <a class="nav-item nav-link" href="{% url 'story9:login' %}" style="color:white">Log In</a>
          <a class="nav-item nav-link" href="{% url 'story9:signup' %}" style="color:white">Sign Up</a>
        </div>
        {% endif %}
      
    </div>
  </nav>

  <div class = "container pt-4">
    <img src="{{ user.profile.image }}" alt="profilePic" style="width: 200px; height: 200px;">
    {% if user.profile.fname != "" %}
    <h1>Halo {{user.profile.fname}} {{user.profile.lname}}</h1><br>
    {% else %}
    <h1>Halo {{user}}</h1>
    {% endif %}

    <div id="editProfile" data-toggle="modal" data-target="#edit" type="button" class="btn btn-outline-dark">Edit Profile</div>
  </div>

  <div class="modal fade" id="edit" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Edit User Profile</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <form action="{% url 'story9:profile' %}" method="POST">
        <div class="modal-body">            
                {% csrf_token %}
                {{form|crispy}}
                                        
        </div>
        <div class="modal-footer">
            <button id="saveEdit" type="submit" class="btn btn-dark mr-2">Save</button>
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        </div>
        </form> 
      </div>
    </div>
  </div>
{% endblock content %}

story9/templates/story9/signup.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
  <title>Story 9|SIGNUP</title>
  
{% endblock meta %}
{% load crispy_forms_tags %}
{% block content %}

<nav class="navbar bg-dark navbar-expand-lg" >
    <a class="navbar-brand" href="#" style="color:white">
      Story 9
    </a>

    <div class="collapse navbar-collapse" id="navbarNavAltMarkup">
        <div class="navbar-nav mr-auto">
          <a class="nav-item nav-link" href="{% url 'story9:index' %}" style="color:white">Home</a>
        </div>
  
        {% if user.is_authenticated %}
        <div class="navbar-nav ml-auto">  
          <a class="nav-item nav-link" href="{% url 'story9:logout' %}" style="color:white">Log Out</a>
        </div>
        {% else %}
        <div class="navbar-nav ml-auto">  
          <a class="nav-item nav-link" href="{% url 'story9:login' %}" style="color:white">Log In</a>
          <a class="nav-item nav-link" href="{% url 'story9:signup' %}" style="color:white">Sign Up</a>
        </div>
        {% endif %}
      
    </div>
  </nav>

  <div class = "container pt-4">
  <form method="POST", class="form-group">
      {% csrf_token %}
      
      {{ form|crispy }}
      <button type="submit" class="btn btn-success">Sign Up</button>
  </form>
  </div>
{% endblock content %}

templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
  <link rel="stylesheet" href="{% static 'css/style.css' %}">

  <script src="https://kit.fontawesome.com/f1aec82d06.js" crossorigin="anonymous"></script>
  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" crossorigin="anonymous"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <!--Other Meta-->
  {% block meta %}
  {% endblock meta %}
</head>

<body>
  {% block content %}
  {% endblock content %}  
</body>

</html>